]> gitweb.michael.orlitzky.com - apply-default-acl.git/blobdiff - run-tests.sh
safe_open_ex: add a comment about why O_PATH doesn't work.
[apply-default-acl.git] / run-tests.sh
index 7b445502ea910a08e54bc4c84d146b9274e6a6b6..07ad496584faa680cde5992e2fde03dee698e628 100755 (executable)
@@ -1,14 +1,46 @@
 #!/bin/bash
 
+#
+# Exit codes
+#
+
+EXIT_SUCCESS=0
+
+# Exit with this when a test fails.
+EXIT_FAILURE=1
+
+# We use a few system users in the tests. If these users aren't
+# present, we exit with a different (non-EXIT_FAILURE).
+EXIT_MISSING_USERS=2
+
+# Define the users that we'll use in the tests below. We store the
+# names as variables to avoid repeating them everywhere.
+#
+# WARNING: These must be in alphabetical order; otherwise the getfacl
+# output will not match.
+#
+USERS=( bin daemon )
+
+# Check to see if the above users exist. If not, bail.
+for idx in $( seq 0 $((${#USERS[@]} - 1)) ); do
+    id "${USERS[idx]}" >/dev/null 2>&1
+
+    if [ $? -ne $EXIT_SUCCESS ]; then
+       echo "Error: missing test user ${USERS[idx]}." 1>&2
+       exit $EXIT_MISSING_USERS
+    fi
+done
+
 # The program name.
-BIN=./reapply_default_acl
+BIN=$(realpath src/apply-default-acl)
 
 # The directory where we'll do all the ACL manipulation.
 TESTDIR=test
 
 acl_reset() {
     # Remove any ACLs on our test directory and remove its contents.
-    setfacl --remove-all --recursive "$TESTDIR"
+    setfacl --remove-all --recursive "${TESTDIR}"
+    chmod 755 "${TESTDIR}"
     rm -rf "${TESTDIR}"/*
 }
 
@@ -18,11 +50,15 @@ compare() {
        acl_reset
     else
        echo "Failure (#${TESTNUM})"
-       echo "Expected result:"
+       echo 'Expected result:'
+       echo '================'
        echo "${EXPECTED}"
-       echo "Actual result:"
+       echo '================'
+       echo 'Actual result:'
+       echo '================'
        echo "${ACTUAL}"
-       exit 1
+       echo '================'
+       exit $EXIT_FAILURE
     fi
 }
 
@@ -35,11 +71,11 @@ mkdir "${TESTDIR}"
 # permissions should all be propagated to the mode bits.
 TESTNUM=1
 TARGET="${TESTDIR}"/foo
+touch "${TARGET}"
+chmod 777 "${TARGET}"
 setfacl -d -m user::r--  "${TESTDIR}"
 setfacl -d -m group::r-- "${TESTDIR}"
 setfacl -d -m other::r-- "${TESTDIR}"
-touch "${TARGET}"
-chmod 777 "${TARGET}"
 $BIN "${TARGET}"
 
 EXPECTED=$(cat <<EOF
@@ -50,7 +86,7 @@ other::r--
 EOF
 )
 
-ACTUAL=`getfacl --omit-header "${TARGET}"`
+ACTUAL=$(getfacl --omit-header "${TARGET}")
 compare
 
 # Do the same thing as the last test, except with an extended ACL.
@@ -58,14 +94,14 @@ TESTNUM=2
 setfacl -d -m user::r--     "${TESTDIR}"
 setfacl -d -m group::r--    "${TESTDIR}"
 setfacl -d -m other::r--    "${TESTDIR}"
-setfacl -d -m user:mail:rwx "${TESTDIR}"
+setfacl -d -m user:${USERS[0]}:rwx "${TESTDIR}"
 touch "${TARGET}"
 chmod 777 "${TARGET}"
 $BIN "${TARGET}"
 
 EXPECTED=$(cat <<EOF
 user::r--
-user:mail:rwx
+user:${USERS[0]}:rwx
 group::r--
 mask::rwx
 other::r--
@@ -73,32 +109,35 @@ other::r--
 EOF
 )
 
-ACTUAL=`getfacl --omit-header "${TARGET}"`
+ACTUAL=$(getfacl --omit-header "${TARGET}")
 compare
 
+
 # A file shared by a group, should still be group-writable
 # afterwards.
 TESTNUM=3
 touch "${TARGET}"
 chmod 644 "${TARGET}"
-setfacl -d -m group:mail:rwx "${TESTDIR}"
+setfacl -d -m group:${USERS[0]}:rwx "${TESTDIR}"
 $BIN "${TARGET}"
 
 EXPECTED=$(cat <<EOF
 user::rw-
 group::r--
-group:mail:rwx #effective:rw-
+group:${USERS[0]}:rwx  #effective:rw-
 mask::rw-
 other::r--
+
 EOF
 )
 
-ACTUAL=`getfacl --omit-header "${TARGET}"`
+ACTUAL=$(getfacl --omit-header "${TARGET}")
 compare
 
+
 # Same test as before except with a directory.
 TESTNUM=4
-setfacl -d -m group:mail:rwx "${TESTDIR}"
+setfacl -d -m group:${USERS[0]}:rwx "${TESTDIR}"
 mkdir "${TARGET}"
 chmod 755 "${TARGET}"
 $BIN "${TARGET}"
@@ -106,19 +145,19 @@ $BIN "${TARGET}"
 EXPECTED=$(cat <<EOF
 user::rwx
 group::r-x
-group:mail:rwx
+group:${USERS[0]}:rwx
 mask::rwx
 other::r-x
 default:user::rwx
 default:group::r-x
-default:group:mail:rwx
+default:group:${USERS[0]}:rwx
 default:mask::rwx
 default:other::r-x
 
 EOF
 )
 
-ACTUAL=`getfacl --omit-header "${TARGET}"`
+ACTUAL=$(getfacl --omit-header "${TARGET}")
 compare
 
 
@@ -137,7 +176,7 @@ other::r--
 EOF
 )
 
-ACTUAL=`getfacl --omit-header "${TARGET}"`
+ACTUAL=$(getfacl --omit-header "${TARGET}")
 compare
 
 
@@ -147,13 +186,13 @@ compare
 TESTNUM=6
 touch "${TARGET}"
 chmod 744 "${TARGET}"
-setfacl -d -m user:mail:rwx "${TESTDIR}"
+setfacl -d -m user:${USERS[0]}:rwx "${TESTDIR}"
 $BIN "${TARGET}"
 
 
 EXPECTED=$(cat <<EOF
 user::rwx
-user:mail:rwx
+user:${USERS[0]}:rwx
 group::r-x
 mask::rwx
 other::r-x
@@ -161,7 +200,7 @@ other::r-x
 EOF
 )
 
-ACTUAL=`getfacl --omit-header "${TARGET}"`
+ACTUAL=$(getfacl --omit-header "${TARGET}")
 compare
 
 
@@ -170,16 +209,21 @@ compare
 TESTNUM=7
 touch "${TARGET}"
 chmod 744 "${TARGET}"
-setfacl -m user:news:rw "${TARGET}"
-setfacl -d -m user:mail:rwx "${TESTDIR}"
-setfacl -d -m user:news:rwx "${TESTDIR}"
+setfacl -m user:${USERS[1]}:rw "${TARGET}"
+# If we don't add 'x' to the mask here, nobody can execute the file.
+# setfacl will update the mask for us under most circumstances, but
+# note that we didn't create an entry with an 'x' bit using setfacl --
+# therefore, setfacl won't unmask 'x' for us.
+setfacl -m mask::rwx "${TARGET}"
+setfacl -d -m user:${USERS[0]}:rwx "${TESTDIR}"
+setfacl -d -m user:${USERS[1]}:rwx "${TESTDIR}"
 $BIN "${TARGET}"
 
 
 EXPECTED=$(cat <<EOF
 user::rwx
-user:mail:rwx
-user:news:rwx
+user:${USERS[0]}:rwx
+user:${USERS[1]}:rwx
 group::r-x
 mask::rwx
 other::r-x
@@ -187,7 +231,7 @@ other::r-x
 EOF
 )
 
-ACTUAL=`getfacl --omit-header "${TARGET}"`
+ACTUAL=$(getfacl --omit-header "${TARGET}")
 compare
 
 
@@ -195,14 +239,14 @@ compare
 TESTNUM=8
 touch "${TARGET}"
 chmod 644 "${TARGET}"
-setfacl -m user:news:rw "${TARGET}"
-setfacl -d -m user:mail:rwx "${TESTDIR}"
+setfacl -m user:${USERS[1]}:rw "${TARGET}"
+setfacl -d -m user:${USERS[0]}:rwx "${TESTDIR}"
 $BIN "${TARGET}"
 
 
 EXPECTED=$(cat <<EOF
 user::rw-
-user:mail:rwx  #effective:rw-
+user:${USERS[0]}:rwx   #effective:rw-
 group::r--
 mask::rw-
 other::r--
@@ -210,7 +254,7 @@ other::r--
 EOF
 )
 
-ACTUAL=`getfacl --omit-header "${TARGET}"`
+ACTUAL=$(getfacl --omit-header "${TARGET}")
 compare
 
 
@@ -230,7 +274,7 @@ other::r-x
 EOF
 )
 
-ACTUAL=`getfacl --omit-header "${TARGET}"`
+ACTUAL=$(getfacl --omit-header "${TARGET}")
 compare
 
 
@@ -240,14 +284,14 @@ TESTNUM=10
 TARGET="${TESTDIR}"/foo
 touch "${TARGET}"
 chmod 777 "${TARGET}"
-setfacl -m user:mail:rwx "${TESTDIR}"
-setfacl -d -m user:mail:rwx  "${TESTDIR}"
+setfacl -m user:${USERS[0]}:rwx "${TESTDIR}"
+setfacl -d -m user:${USERS[0]}:rwx  "${TESTDIR}"
 setfacl -d -m mask::rw-  "${TESTDIR}"
 $BIN "${TARGET}"
 
 EXPECTED=$(cat <<EOF
 user::rwx
-user:mail:rwx  #effective:rw-
+user:${USERS[0]}:rwx   #effective:rw-
 group::r-x     #effective:r--
 mask::rw-
 other::r-x
@@ -255,7 +299,7 @@ other::r-x
 EOF
 )
 
-ACTUAL=`getfacl --omit-header "${TARGET}"`
+ACTUAL=$(getfacl --omit-header "${TARGET}")
 compare
 
 
@@ -279,7 +323,7 @@ other::r--
 EOF
 )
 
-ACTUAL=`getfacl --omit-header "${TARGET}"`
+ACTUAL=$(getfacl --omit-header "${TARGET}")
 compare
 
 
@@ -304,7 +348,7 @@ other::r--
 EOF
 )
 
-ACTUAL=`getfacl --omit-header "${TARGET}"/bar/quux`
+ACTUAL=$(getfacl --omit-header "${TARGET}"/bar/quux)
 compare
 
 
@@ -329,8 +373,496 @@ other::r--
 default:user::rwx
 default:group::r--
 default:other::r--
+
+EOF
+)
+
+ACTUAL=$(getfacl --omit-header "${TARGET}"/bar)
+compare
+
+
+# Test double application on a directory.
+#
+TESTNUM=14
+TARGET="${TESTDIR}"/baz
+mkdir "${TARGET}"
+chmod 644 "${TARGET}"
+setfacl -d -m user:${USERS[0]}:rwx "${TESTDIR}"
+
+$BIN "${TARGET}"
+$BIN "${TARGET}"
+
+EXPECTED=$(cat <<EOF
+user::rwx
+user:${USERS[0]}:rwx
+group::r-x
+mask::rwx
+other::r-x
+default:user::rwx
+default:user:${USERS[0]}:rwx
+default:group::r-x
+default:mask::rwx
+default:other::r-x
+
+EOF
+)
+
+ACTUAL=$(getfacl --omit-header "${TARGET}")
+compare
+
+
+# Same as previous test, with 755 initial perms.
+#
+TESTNUM=15
+TARGET="${TESTDIR}"/baz
+mkdir "${TARGET}"
+chmod 755 "${TARGET}"
+setfacl -d -m user:${USERS[0]}:rwx "${TESTDIR}"
+
+$BIN "${TARGET}"
+$BIN "${TARGET}"
+
+EXPECTED=$(cat <<EOF
+user::rwx
+user:${USERS[0]}:rwx
+group::r-x
+mask::rwx
+other::r-x
+default:user::rwx
+default:user:${USERS[0]}:rwx
+default:group::r-x
+default:mask::rwx
+default:other::r-x
+
+EOF
+)
+
+ACTUAL=$(getfacl --omit-header "${TARGET}")
+compare
+
+
+# Same as previous two tests, only with a file.
+#
+TESTNUM=16
+TARGET="${TESTDIR}"/foo
+touch "${TARGET}"
+chmod 644 "${TARGET}"
+setfacl -d -m user:${USERS[0]}:rwx "${TESTDIR}"
+
+$BIN "${TARGET}"
+$BIN "${TARGET}"
+
+EXPECTED=$(cat <<EOF
+user::rw-
+user:${USERS[0]}:rwx   #effective:rw-
+group::r--
+mask::rw-
+other::r--
+EOF
+)
+
+ACTUAL=$(getfacl --omit-header "${TARGET}")
+compare
+
+
+# User-executable files should not wind up exec-masked.
+TESTNUM=17
+TARGET="${TESTDIR}"/foo
+touch "${TARGET}"
+chmod 700 "${TARGET}"
+setfacl -d -m user:${USERS[0]}:rwx  "${TESTDIR}"
+$BIN "${TARGET}"
+
+EXPECTED=$(cat <<EOF
+user::rwx
+user:${USERS[0]}:rwx
+group::r-x
+mask::rwx
+other::r-x
+
+EOF
+)
+
+ACTUAL=$(getfacl --omit-header "${TARGET}")
+compare
+
+
+# Group-executable files should not wind up exec-masked.
+TESTNUM=18
+TARGET="${TESTDIR}"/foo
+touch "${TARGET}"
+chmod 670 "${TARGET}"
+setfacl -d -m user:${USERS[0]}:rwx  "${TESTDIR}"
+$BIN "${TARGET}"
+
+EXPECTED=$(cat <<EOF
+user::rwx
+user:${USERS[0]}:rwx
+group::r-x
+mask::rwx
+other::r-x
+
+EOF
+)
+
+ACTUAL=$(getfacl --omit-header "${TARGET}")
+compare
+
+
+# Other-executable files should not wind up exec-masked.
+TESTNUM=19
+TARGET="${TESTDIR}"/foo
+touch "${TARGET}"
+chmod 607 "${TARGET}"
+setfacl -d -m user:${USERS[0]}:rwx  "${TESTDIR}"
+$BIN "${TARGET}"
+
+EXPECTED=$(cat <<EOF
+user::rwx
+user:${USERS[0]}:rwx
+group::r-x
+mask::rwx
+other::r-x
+
+EOF
+)
+
+ACTUAL=$(getfacl --omit-header "${TARGET}")
+compare
+
+
+
+# Test #16's setup repeated with the --no-exec-mask flag.
+#
+TESTNUM=20
+TARGET="${TESTDIR}"/foo
+touch "${TARGET}"
+chmod 644 "${TARGET}"
+# The directory allows execute for user, group, and other, so the file
+# should actually inherit them regardless of its initial mode when the
+# --no-exec-mask flag is passed.
+setfacl -d -m user:${USERS[0]}:rwx "${TESTDIR}"
+
+$BIN --no-exec-mask "${TARGET}"
+
+EXPECTED=$(cat <<EOF
+user::rwx
+user:${USERS[0]}:rwx
+group::r-x
+mask::rwx
+other::r-x
+EOF
+)
+
+ACTUAL=$(getfacl --omit-header "${TARGET}")
+compare
+
+
+
+# Test #20 repeated recursively to make sure the flags play nice
+# together.
+TESTNUM=21
+PARENT_DIR="${TESTDIR}"/foo
+TARGET="${PARENT_DIR}"/bar
+mkdir "${PARENT_DIR}"
+touch "${TARGET}"
+chmod 644 "${TARGET}"
+setfacl -d -m user:${USERS[0]}:rwx "${TESTDIR}"
+
+$BIN --recursive --no-exec-mask "${PARENT_DIR}"
+
+EXPECTED=$(cat <<EOF
+user::rwx
+user:${USERS[0]}:rwx
+group::r-x
+mask::rwx
+other::r-x
+EOF
+)
+
+ACTUAL=$(getfacl --omit-header "${TARGET}")
+compare
+
+
+# Make sure a mask with an execute bit doesn't count as being
+# executable.
+#
+TESTNUM=22
+TARGET="${TESTDIR}"/foo
+touch "${TARGET}"
+chmod 644 "${TARGET}"
+setfacl -m user::rw "${TARGET}"
+setfacl -m group::rw "${TARGET}"
+# Even though the mask has an 'x' bit, nobody can execute it.
+setfacl -m mask::rwx "${TARGET}"
+setfacl -d -m user::rwx "${TESTDIR}"
+setfacl -d -m group::rwx "${TESTDIR}"
+$BIN "${TARGET}"
+
+
+EXPECTED=$(cat <<EOF
+user::rw-
+group::rw-
+other::r--
+
+EOF
+)
+
+ACTUAL=$(getfacl --omit-header "${TARGET}")
+compare
+
+
+# Same as test #2, except we pass multiple files on the command
+# line and check the result of the first one.
+TESTNUM=23
+setfacl -d -m user::r--     "${TESTDIR}"
+setfacl -d -m group::r--    "${TESTDIR}"
+setfacl -d -m other::r--    "${TESTDIR}"
+setfacl -d -m user:${USERS[0]}:rwx "${TESTDIR}"
+DUMMY="${TESTDIR}/dummy"
+touch "${DUMMY}"
+chmod 777 "${DUMMY}"
+touch "${TARGET}"
+chmod 777 "${TARGET}"
+$BIN "${TARGET}" "${DUMMY}"
+
+EXPECTED=$(cat <<EOF
+user::r--
+user:${USERS[0]}:rwx
+group::r--
+mask::rwx
+other::r--
+
+EOF
+)
+
+ACTUAL=$(getfacl --omit-header "${TARGET}")
+compare
+
+
+
+# Same as the previous test with the argument order switched.
+TESTNUM=24
+setfacl -d -m user::r--     "${TESTDIR}"
+setfacl -d -m group::r--    "${TESTDIR}"
+setfacl -d -m other::r--    "${TESTDIR}"
+setfacl -d -m user:${USERS[0]}:rwx "${TESTDIR}"
+DUMMY="${TESTDIR}/dummy"
+touch "${DUMMY}"
+chmod 777 "${DUMMY}"
+touch "${TARGET}"
+chmod 777 "${TARGET}"
+$BIN "${DUMMY}" "${TARGET}"
+
+EXPECTED=$(cat <<EOF
+user::r--
+user:${USERS[0]}:rwx
+group::r--
+mask::rwx
+other::r--
+
+EOF
+)
+
+ACTUAL=$(getfacl --omit-header "${TARGET}")
+compare
+
+
+# If we call apply-default-acl on a single file that does not exist,
+# we get the expected error.
+TESTNUM=25
+ACTUAL=$( "${BIN}" test/nonexistent 2>&1 )
+ACTUAL="${ACTUAL#*: }"
+EXPECTED="test/nonexistent: No such file or directory"
+compare
+
+# Same as the previous test, but with --recursive.
+TESTNUM=26
+ACTUAL=$( "${BIN}" --recursive test/nonexistent 2>&1 )
+ACTUAL="${ACTUAL#*: }"
+EXPECTED="test/nonexistent: No such file or directory"
+compare
+
+# If we call apply-default-acl on more than one file, it should report any
+# that don't exist (but proceed to operate on the others).
+TESTNUM=27
+DUMMY1="${TESTDIR}/dummy1"
+DUMMY2="${TESTDIR}/dummy2"
+touch "${DUMMY1}" "${DUMMY2}"
+ACTUAL=$( "${BIN}" "${DUMMY1}" test/nonexistent "${DUMMY2}" 2>&1 )
+ACTUAL="${ACTUAL#*: }"
+EXPECTED="test/nonexistent: No such file or directory"
+compare
+
+
+# Ensure that symlinks are not followed.
+TESTNUM=28
+TARGET="${TESTDIR}/foo"
+LINK2TARGET="${TESTDIR}/foo-sym"
+touch "${TARGET}"
+ln -s "${TARGET#${TESTDIR}/}" "${LINK2TARGET}"
+setfacl --default --modify user:${USERS[0]}:rwx "${TESTDIR}"
+"${BIN}" "${LINK2TARGET}"
+ACTUAL=$( getfacl --omit-header "${TARGET}" )
+EXPECTED=$(cat <<EOF
+user::rw-
+group::r--
+other::r--
+
+EOF
+)
+compare
+
+
+# Ensure that symlinks are not followed in subdirectories
+# (recursively).
+TESTNUM=29
+TARGET="${TESTDIR}/bar"
+touch "${TARGET}"
+mkdir "${TESTDIR}/foo"
+LINK2TARGET="${TESTDIR}/foo/bar-sym"
+ln -s "../bar" "${LINK2TARGET}"
+setfacl --default --modify user:${USERS[0]}:rwx "${TESTDIR}/foo"
+"${BIN}" --recursive "${TESTDIR}/foo"
+ACTUAL=$( getfacl --omit-header "${TARGET}" )
+EXPECTED=$(cat <<EOF
+user::rw-
+group::r--
+other::r--
+
+EOF
+)
+compare
+
+
+# Ensure that hard links are ignored.
+TESTNUM=30
+TARGET="${TESTDIR}/foo"
+LINK2TARGET="${TESTDIR}/bar"
+touch "${TARGET}"
+ln "${TARGET}" "${LINK2TARGET}"
+setfacl --default --modify user:${USERS[0]}:rwx "${TESTDIR}"
+"${BIN}" "${LINK2TARGET}"
+ACTUAL=$( getfacl --omit-header "${TARGET}" )
+EXPECTED=$(cat <<EOF
+user::rw-
+group::r--
+other::r--
+
+EOF
+)
+compare
+
+
+# We should be able to run the tool with a relative path from within a
+# directory that contains a symlink, so long as the relative path
+# doesn't contain one.
+TESTNUM=31
+TARGET="${TESTDIR}/foo/bar"
+LINK2TARGET="${TESTDIR}/baz"
+mkdir -p $(dirname "${TARGET}")
+touch "${TARGET}"
+ln -s foo "${TESTDIR}/baz"
+setfacl --default --modify user:${USERS[0]}:rw $(dirname "${TARGET}")
+pushd "${TESTDIR}/baz" > /dev/null
+"${BIN}" bar
+popd > /dev/null
+ACTUAL=$( getfacl --omit-header "${TARGET}" )
+EXPECTED=$(cat <<EOF
+user::rw-
+user:${USERS[0]}:rw-
+group::r--
+mask::rw-
+other::r--
+
+EOF
+)
+compare
+
+
+# Ensure that symlinks in non-terminal path components are not followed.
+TESTNUM=32
+TARGET="${TESTDIR}/foo/bar/baz"
+LINK2FOO="${TESTDIR}/quux"
+mkdir -p $(dirname "${TARGET}")
+touch "${TARGET}"
+ln -s foo "${LINK2FOO}"
+setfacl --default --modify user:${USERS[0]}:rw $(dirname "${TARGET}")
+"${BIN}" "${LINK2FOO}/bar/baz"
+ACTUAL=$( getfacl --omit-header "${TARGET}" )
+EXPECTED=$(cat <<EOF
+user::rw-
+group::r--
+other::r--
+
 EOF
 )
+compare
+
+
+# Test that our exit code succeeds on a single, normal path.
+TESTNUM=33
+TARGET="${TESTDIR}/foo"
+touch "${TARGET}"
+setfacl --default --modify user:${USERS[0]}:rw "${TESTDIR}"
+"${BIN}" "${TARGET}"
+ACTUAL="$?"
+EXPECTED="0"
+compare
+
+
+# Test that our exit code fails on a symlink.
+TESTNUM=34
+TARGET="${TESTDIR}/bar"
+touch "${TESTDIR}/foo"
+ln -s foo "${TARGET}"
+setfacl --default --modify user:${USERS[0]}:rw "${TESTDIR}"
+"${BIN}" "${TARGET}"
+ACTUAL="$?"
+EXPECTED="1"
+compare
+
+
+# The previous test should "succeed" if we use --recursive. This is
+# buggy, but it's documented.
+TESTNUM=35
+TARGET="${TESTDIR}/bar"
+touch "${TESTDIR}/foo"
+ln -s foo "${TARGET}"
+setfacl --default --modify user:${USERS[0]}:rw "${TESTDIR}"
+"${BIN}" --recursive "${TARGET}"
+ACTUAL="$?"
+EXPECTED="0"
+compare
+
+
+# Test the return value for nonexistent paths.
+TESTNUM=36
+TARGET="${TESTDIR}/foo"
+"${BIN}" "${TARGET}" &>/dev/null
+ACTUAL="$?"
+EXPECTED="1"
+compare
+
+
+# Test that one "failure" exit code overrides two "successes"
+TESTNUM=37
+mkdir "${TESTDIR}/foo"
+ln -s foo "${TESTDIR}/bar"
+mkdir "${TESTDIR}/baz"
+"${BIN}" "${TESTDIR}/foo" "${TESTDIR}/bar" "${TESTDIR}/baz"
+ACTUAL="$?"
+EXPECTED="1"
+compare
+
 
-ACTUAL=`getfacl --omit-header "${TARGET}"/bar`
+# And test the buggy behavior again; the previous test should return
+# success (ignoring the failure) when --recursive is used.
+TESTNUM=38
+mkdir "${TESTDIR}/foo"
+ln -s foo "${TESTDIR}/bar"
+mkdir "${TESTDIR}/baz"
+"${BIN}" --recursive "${TESTDIR}"
+ACTUAL="$?"
+EXPECTED="0"
 compare